package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesDefectAlarmConfigService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesDefectAlarmConfig;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class MesDefectAlarmConfigService extends BaseMesService<MesDefectAlarmConfig> implements IMesDefectAlarmConfigService {


    protected void onInsertBean(MesDefectAlarmConfig item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getPartTypeCode(), "零件类型不能为空");

    }

    protected void onUpdateBean(MesDefectAlarmConfig item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getPartTypeCode(), "零件类型不能为空");
    }

    protected void setPackQueryBean(MesDefectAlarmConfig bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getDefectCode(), "defectCode", packBean);
        DdlPreparedPack.getNumEqualPack(bean.getTotalTriggerCount(), "totalTriggerCount", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getDefectLocation(), "defectLocation", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getPartTypeCode(), "partTypeCode", packBean);
    }

}
